﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinSchedule

Public Class Form1

    Dim scheduleData As DataSet
    Dim citas As DataTable
    Dim george As Owner
    Dim paul As Owner

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        scheduleData = New DataSet()
        UltraCalendarLook1.ViewStyle = ViewStyle.Office2007
        UltraTimelineView1.CalendarInfo = UltraCalendarInfo1
        UltraTimelineView1.CalendarLook = UltraCalendarLook1

        SetAppointmentBindings()

    End Sub

    Private Function BuildTable() As DataTable

        citas = New DataTable("Appointments")
        
        paul = UltraCalendarInfo1.Owners.Add("Paul")
        george = UltraCalendarInfo1.Owners.Add("George")

        citas.Columns.Add("Subject", GetType(String))
        citas.Columns("Subject").DefaultValue = "Reunion"
        citas.Columns.Add("StartDateTime", GetType(DateTime))
        citas.Columns("StartDateTime").DefaultValue = DateTime.Now
        citas.Columns.Add("EndDateTime", GetType(DateTime))
        citas.Columns("EndDateTime").DefaultValue = DateTime.Now.AddHours(1)
        citas.Columns.Add("Description", GetType(String))

        ' All other fields are Optional.

        'Properties for AllDayEvents
        citas.Columns.Add("AllDayEvent", GetType(Boolean))
        citas.Columns("AllDayEvent").DefaultValue = False

        'Properties for Reminders
        citas.Columns.Add("ReminderEnabled", GetType(Boolean))
        citas.Columns("ReminderEnabled").DefaultValue = False
        citas.Columns.Add("ReminderInterval", GetType(Integer))
        citas.Columns.Add("ReminderUnits", GetType(Integer))

        'Properties when imports owners
        citas.Columns.Add("OwnerKey", GetType(String))

        'Properties when imports recurring appointments. 
        citas.Columns.Add("RecurrenceId", GetType(System.Guid))
        citas.Columns.Add("Recurrence", GetType(Byte()))
        citas.Columns.Add("OriginalStartDateTime", GetType(DateTime))

        'DataKey is an extra field that can be used to link the appointment to some external data. 
        citas.Columns.Add("DataKey", GetType(String))

        'All properties 			
        ' Any other Appointment properties not covered above are stored as 
        ' Binary data in the AllProperties field. This includes properties like 
        ' BarColor, Location, etc. 
        citas.Columns.Add("AllProperties", GetType(Byte()))

        Dim row As DataRow = citas.NewRow()
        'row("Appointment") = appt1
        citas.Rows.Add(row)

        row = citas.NewRow()
        row("Subject") = "Lunch with Paul"
        row("StartDateTime") = DateTime.Today.AddHours(13)
        row("EndDateTime") = DateTime.Today.AddHours(14)
        row("AllDayEvent") = False
        row("Description") = "Lunch at The Crown of India"
        row("OwnerKey") = "Paul"
        citas.Rows.Add(row)

        Me.UltraCalendarInfo1.DataBindingsForAppointments.DataSource = citas.DefaultView
        Me.UltraCalendarInfo1.DataBindingsForAppointments.BindingContextControl = Me

        Return citas
    End Function

    Private Sub SetAppointmentBindings()
        '	Get the data
        Me.scheduleData.Tables.Add(Me.BuildTable())

        ' Set the BindingContextControl so the component will use the same context
        ' that the grid and any other controls on the form are using. 
        Me.ultraCalendarInfo1.DataBindingsForAppointments.BindingContextControl = Me

        ' Basic Appointment properties
        Me.ultraCalendarInfo1.DataBindingsForAppointments.SubjectMember = "Subject"
        Me.ultraCalendarInfo1.DataBindingsForAppointments.DescriptionMember = "Description"

        Me.ultraCalendarInfo1.DataBindingsForAppointments.StartDateTimeMember = "StartDateTime"
        Me.ultraCalendarInfo1.DataBindingsForAppointments.EndDateTimeMember = "EndDateTime"
        Me.ultraCalendarInfo1.DataBindingsForAppointments.AllDayEventMember = "AllDayEvent"

        Me.ultraCalendarInfo1.DataBindingsForAppointments.ReminderEnabledMember = "ReminderEnabled"
        Me.ultraCalendarInfo1.DataBindingsForAppointments.ReminderIntervalMember = "ReminderInterval"
        Me.ultraCalendarInfo1.DataBindingsForAppointments.ReminderUnitsMember = "ReminderUnits"

        'Properties when imports owners
        Me.ultraCalendarInfo1.DataBindingsForAppointments.OwnerKeyMember = "OwnerKey"

        'Properties when imports recurring appointments. 
        Me.ultraCalendarInfo1.DataBindingsForAppointments.RecurrenceIdMember = "RecurrenceId"
        Me.ultraCalendarInfo1.DataBindingsForAppointments.RecurrenceMember = "Recurrence"
        Me.ultraCalendarInfo1.DataBindingsForAppointments.OriginalStartDateTimeMember = "OriginalStartDateTime"

        ' All other properties
        Me.ultraCalendarInfo1.DataBindingsForAppointments.AllPropertiesMember = "AllProperties"

        'DataKey is an extra field that can be used to link the appointment to some external data. 
        Me.ultraCalendarInfo1.DataBindingsForAppointments.DataKeyMember = "DataKey"

        ' DataSource & DataMember
        Me.ultraCalendarInfo1.DataBindingsForAppointments.SetDataBinding(Me.scheduleData, String.Empty)
    End Sub

    Private Sub addButton_Click(sender As Object, e As EventArgs) Handles addButton.Click
        Dim appointment As DataRow
        appointment = citas.NewRow()
        appointment("Subject") = "Meeting with George"
        appointment("StartDateTime") = DateTime.Today.AddHours(15)
        appointment("EndDateTime") = DateTime.Today.AddHours(16)
        appointment("AllDayEvent") = False
        appointment("Description") = "Review"
        appointment("OwnerKey") = "George"
        citas.Rows.Add(appointment)
        
    End Sub
End Class
